import numpy as np

# ------------------------------------------------------------------------------
# Global variable for timestamping

time = 0

# ------------------------------------------------------------------------------
# The Vertex class

class Vertex:
    def __init__(self, label, color='WHITE', predec=None):
        self.label = label
        self.color = color
        self.predec = predec
        self.d = 0
        self.f = 0

# ------------------------------------------------------------------------------
# The DFS-Visit function

def DFS_Visit(V, adj, u):
    global time

    time = time + 1
    u.d = time
    u.color = 'GRAY'

    for nbr in adj[u.label]:
        v = V[nbr]
        if v.color == 'WHITE':
            v.predec = u
            DFS_Visit(V, adj, v)

    time = time + 1
    u.f = time
    u.color = 'BLACK'

# ------------------------------------------------------------------------------
# The input graph

adj = { 'u': ['v', 'x'],
        'v': ['y'],
        'w': ['y', 'z'],
        'x': ['v'],
        'y': ['x'],
        'z': ['z'] }

# ------------------------------------------------------------------------------
# Initialize the traversal

V = {}
for v in adj.keys(): V[v] = Vertex(v)

# ------------------------------------------------------------------------------
# Do the DFS traversal

for v in V.keys():
    u = V[v]
    if u.color == 'WHITE':
        DFS_Visit(V, adj, u)

# ------------------------------------------------------------------------------
# Print discovery and final times

for v in V.keys():
    u = V[v]
    print(f'Vertex: {u.label}  Times: {u.d}/{u.f}')
